import { prompt } from 'inquirer'
import { Item, Tarefas, Tarefa } from '../../../curio'
import { accessSubtask } from '../../../constants/questions'
import * as chalk from 'chalk'

export default async function tarefa (tarefas: Tarefas, anteriores?: Tarefas): Promise<void|Tarefa> {
  let items: Tarefa[] = tarefas[0].Tarefa
  items = items
  .filter(item => item._Ativo === 'S' || item.TarefasFilhas)
  .filter(item => item.TarefasFilhas || item._PermiteRegistro === 'S')
  items.forEach(item => {
    if (item.TarefasFilhas && item.TarefasFilhas[0].Tarefa.every(item => item._Ativo === 'N')) delete item.TarefasFilhas
  })
  if (!items.length) return console.log(`Nenhuma Tarefa ${chalk.red('ativa')} encontrada`)
  const choices = (anteriores ? [{name: '..', value: '-1'}] : []).concat(
    items.map((item, i) => ({
      name: item.TarefasFilhas
      ? chalk.bold.italic.green('+ ') + item._Descricao
      : (anteriores ? chalk.bold.italic.green('- ') : '') + item._Descricao,
      value: i.toString()
    }))
  )
  const response = await prompt({
    type: 'list',
    name: 'tarefa',
    message: anteriores ? '                  :' : 'Escolha uma Tarefa:',
    choices
  })
  if (response.tarefa === '-1') return tarefa(anteriores)
  const {TarefasFilhas, _PermiteRegistro, _Descricao, _OID} = items[response.tarefa]
  if (!TarefasFilhas) {
    if (_PermiteRegistro === 'S') return items[response.tarefa]
    return console.log(`${chalk.red('×')} A Tarefa ${chalk.underline.red(_Descricao)} não permite registro`)
  }
  if (TarefasFilhas) {
    if (_PermiteRegistro === 'S') {
      if (!await accessSubtask(_Descricao)) return items[response.tarefa]
      return tarefa(TarefasFilhas, tarefas)
    }
    return tarefa(TarefasFilhas, tarefas)
  }
}
